package com.mc.monkeynes.base;

import java.io.*;
import java.util.*;


public class GenericFileFilter extends javax.swing.filechooser.FileFilter implements FileFilter
{
  private ArrayList extensions   = new ArrayList();
  private String    description  = "";
  private boolean   showDirs     = false;

  public GenericFileFilter()
  {
    // Do nothing...
  }

  public GenericFileFilter( ArrayList inExtensions )
  {
    extensions  = inExtensions;
  }  
  
  public GenericFileFilter( ArrayList inExtensions, boolean inShowDirs )
  {
    extensions  = inExtensions;
    showDirs    = inShowDirs;
  }
  
  public GenericFileFilter( ArrayList inExtensions, String inDescription )
  {
    extensions  = inExtensions;
    description = inDescription;
  }  
  
  public GenericFileFilter( ArrayList inExtensions, String inDescription, boolean inShowDirs )
  {
    extensions  = inExtensions;
    description = inDescription;
    showDirs    = inShowDirs;
  }    
  
  // "|" seperated extensions
  public GenericFileFilter( String inExtensions )
  {
    StringTokenizer st = new StringTokenizer( inExtensions, "|" );
    
    while( st.hasMoreTokens() )
      addExtension( st.nextToken() );
  }
  
  // "|" seperated extensions
  public GenericFileFilter( String inExtensions, boolean inShowDirs )
  {
    StringTokenizer st = new StringTokenizer( inExtensions, "|" );
    
    while( st.hasMoreTokens() )
      addExtension( st.nextToken() );
    
    setShowDirs( inShowDirs );
  }  

  // "|" seperated extensions and a description
  public GenericFileFilter( String inExtensions, String inDescription )
  {
    StringTokenizer st = new StringTokenizer( inExtensions, "|" );
    
    while( st.hasMoreTokens() )
      addExtension( st.nextToken() );
      
    setDescription( inDescription );
  }  

  // "|" seperated extensions and a description
  public GenericFileFilter( String inExtensions, String inDescription, boolean inShowDirs )
  {
    StringTokenizer st = new StringTokenizer( inExtensions, "|" );
    
    while( st.hasMoreTokens() )
      addExtension( st.nextToken() );
      
    setDescription( inDescription );
    setShowDirs( inShowDirs );
  }    
  
  public void addExtension( String inExt )
  {
    // Rip off the . and stuff if they exist
    if( inExt.indexOf( "." ) != -1 )
      inExt = inExt.substring( inExt.indexOf( "." ) + 1 );
      
    extensions.add( inExt );
  }
  
  public void setDescription( String inDesc )
  {
    description = inDesc;
  }
  
  public String getDescription()
  {
    return description; 
  }
  
  public void setShowDirs( boolean inShowDirs )
  {
    showDirs = inShowDirs;
  }  

  public boolean accept( File inFile ) 
  {
    if( showDirs && inFile.isDirectory() )
      return true;
    
    if( extensions != null )
    {
      for( int i = 0; i < extensions.size(); i++ )
      {
        if( inFile.getName().endsWith( (String)extensions.get(i) ) )
          return true;
      }
    }
    else
      return true;
    
    return false;
  }
}